#include <iostream>
#include <vector>

using namespace std;

vector <int> nums[100];

int digitsSum(int n)
{
    if (n == 0) return 0;

    int res = 0;
    while (n > 0)
    {
        res += n % 10;
        n /= 10;
    }

    return res;
}

bool isValid(int N)
{
    return N % digitsSum(N) == 0;
}

void init()
{
    int to = 10000000;
    for (int i = 1; i < to; i++)
    {
        if (isValid(i))
        {
            nums[digitsSum(i)].push_back(i);
        }
    }
}

int computeRequest(int L, int R, int D)
{
    auto firstIndex = distance(nums[D].begin(), lower_bound(nums[D].begin(), nums[D].end(), L));
    auto lastIndex = distance(nums[D].begin(), lower_bound(nums[D].begin(), nums[D].end(), R));
    if (nums[D].at(lastIndex) == R) lastIndex++;

    return lastIndex - firstIndex;
}

int main()
{
    init();
    int T, L, D, R;
    cin >> T;

    for (int i = 0; i < T; i++)
    {
        cin >> L >> R >> D;
        cout << computeRequest(L, R, D) << endl;
    }
}
