#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

const int maxn = 1005;

int n;

string s[maxn];

int cost[maxn][maxn];

long long dp[maxn];
int opt[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> s[i];
    }

    for (int i = 1; i <= n; ++i)
    {
        cost[i][i] = 0;

        string curr = s[i];

        for (int j = i + 1; j <= n; ++j)
        {
            int l = 0;
            int r = min(s[j].size(), curr.size());

            while (l <= r)
            {
                int mid = (l + r) / 2;

                if (curr.substr(0, mid) == s[j].substr(0, mid))
                {
                    l = mid + 1;
                }
                else
                {
                    r = mid - 1;
                }
            }

            cost[i][j] = r;

            if (r == 0)
            {
                break;
            }

            curr = curr.substr(0, r);
        }
    }

    /*for (int i = 1; i <= n; ++i)
    {
        for (int j = i + 1; j <= n; ++j)
        {
            cout << cost[i][j] << ' ';
        }

        cout << endl;
    }*/

    long long res = 0;

    for (int i = 1; i <= n; ++i)
    {
        opt[i] = i;

        for (int j = i; j >= 1; --j)
        {
            res = dp[j - 1] + (1LL * cost[j][i]) * (1LL * (i - j + 1));

            if (dp[i] < res)
            {
                dp[i] = res;
                opt[i] = j;
            }
        }
    }

    vector<int> sizes;

    int idx = n;

    while (idx >= 1)
    {
        //cout << idx << ' ' << opt[idx] << endl;
        sizes.push_back(idx - opt[idx] + 1);
        idx = opt[idx] - 1;
    }

    reverse(sizes.begin(), sizes.end());

    cout << dp[n] << ' ' << sizes.size() << endl;

    for (auto x : sizes)
    {
        cout << x << ' ';
    }

    cout << endl;

    return 0;
}
