#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

const int maxn = 1005;

const long long base = 131;
const long long mod = 1000000007;

int n;

string s[maxn];

vector<long long> hashes[maxn];

int cost[maxn][maxn];

long long dp[maxn];
int opt[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> s[i];
    }

    for (int i = 1; i <= n; ++i)
    {
        long long num = 0;
        hashes[i].push_back(0);

        for (int j = 0; j < s[i].size(); ++j)
        {
            num = (num * base + s[i][j]) % mod;
            hashes[i].push_back(num);
        }
    }

    for (int i = 1; i <= n; ++i)
    {
        cost[i][i] = 0;

        int len = s[i].size();

        for (int j = i + 1; j <= n; ++j)
        {
            len = min(len, (int)s[j].size());

            int l = 0;
            int r = len;

            while (l <= r)
            {
                int mid = (l + r) / 2;

                if (hashes[j][mid] == hashes[j - 1][mid])
                {
                    l = mid + 1;
                }
                else
                {
                    r = mid - 1;
                }
            }

            len = r;

            cost[i][j] = r;

            if (r == 0)
            {
                break;
            }
        }
    }

    long long res = 0;

    for (int i = 1; i <= n; ++i)
    {
        opt[i] = i;

        for (int j = i; j >= 1; --j)
        {
            res = dp[j - 1] + (1LL * cost[j][i]) * (1LL * (i - j + 1));

            if (dp[i] < res)
            {
                dp[i] = res;
                opt[i] = j;
            }
        }
    }

    vector<int> sizes;

    int idx = n;

    while (idx >= 1)
    {
        //cout << idx << ' ' << opt[idx] << endl;
        sizes.push_back(idx - opt[idx] + 1);
        idx = opt[idx] - 1;
    }

    reverse(sizes.begin(), sizes.end());

    cout << dp[n] << ' ' << sizes.size() << endl;

    for (auto x : sizes)
    {
        cout << x << ' ';
    }

    cout << endl;

    return 0;
}
